<script setup lang="ts">
import { computed, onMounted, ref, watch } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import GitApiCall from '@/api/gitApi'
import GitlabHelperApi from '@/api/gitlabHelperApi'
import HeaderTemplate from '@/components/gitlab/pipeline/common/HeaderTemplate.vue'
import JobItem from '@/components/gitlab/pipeline/common/JobItem.vue'

const props = defineProps<{ route: string }>()
const emit = defineEmits(['selected-value'])
const route = useRoute()
const store = useStore()
const panel = ref([])
const canceling = ref(false)
const spinning = ref(false)
const user = ref<{ username: string; rol: string }>({ username: '', rol: '' })
const groupId = ref<string | string[]>('0')
const projectId = ref<string | string[]>('0')
const pipelineId = ref<string | string[]>('0')
const project = ref<any>({})
const pipeline = ref<any>({})
const jobsList = ref<any[]>([])
const formJobsContent = ref<any>({})
const timer = ref<number | null>(null)
const selectedValues = ref<string[]>([])
const selectedJobPreview = ref<string>('stages')
const slideGroupKey = ref(0)
const expandedJobIds = ref<number[]>([])
interface JobStatus {
  key: string
  value: string
}

const defaultJobStatus: JobStatus[] = [
  { key: 'created', value: 'Created' },
  { key: 'waiting_for_resource', value: 'Waiting for resource' },
  { key: 'preparing', value: 'Preparing' },
  { key: 'pending', value: 'Pending' },
  { key: 'running', value: 'Running' },
  { key: 'manual', value: 'Manual' },
  { key: 'success', value: 'Success' },
  { key: 'failed', value: 'Failed' },
  { key: 'scheduled', value: 'Scheduled' },
  { key: 'canceling', value: 'Canceling' },
  { key: 'canceled', value: 'Canceled' },
  { key: 'skipped', value: 'Skipped' },
]

const selectedStages = ref<string[]>([])

// Expose values to the template
const statusColors: any = {
  success: '#4CAF50', // Green
  failed: '#F44336', // Red
  running: '#2196F3', // Blue
  pending: '#FF9800', // Orange
  canceled: '#9E9E9E', // Gray
  skipped: '#D3D3D3', // Light gray
  manual: '#9C27B0', // Purple
  created: '#03A9F4', // Light Blue
  preparing: '#FFC107', // Amber
  scheduled: '#00BCD4', // Cyan
  waiting_for_resource: '#FFEB3B', // Yellow
  failed_with_warnings: '#FFC107', // Amber (same as 'preparing')
  default: '#607D8B', // Dark Gray (fallback color)
}

const icon = {
  pending: { color: 'primary', name: 'LoaderIcon' },
  manual: { color: 'warning', name: 'SettingsIcon' },
  running: { color: 'primary', name: 'MoreHorizontalIcon' },
  created: { color: 'secondary', name: 'MoreHorizontalIcon' },
  canceled: { color: 'secondary', name: 'MinusIcon' },
  success: { color: 'success', name: 'CheckIcon' },
  failed: { color: 'danger', name: 'XIcon' },
  skipped: { color: 'secondary', name: 'ChevronsRightIcon' },
}

const jobPreviewOptions = [
  { text: 'Horizontal preview', value: 'horizontal' },
  { text: 'Vertical preview', value: 'vertical' },
  { text: 'Stages preview', value: 'stages' },
]

const selectedJobStatus = ref<JobStatus[]>(
  store.state.selectedJobStatus ? store.state.selectedJobStatus : defaultJobStatus,
)

const selectAll = computed(() => selectedJobStatus.value.length === defaultJobStatus.length)
const uniqueStages = computed(() => [...new Set(jobsList.value.map(job => job.stage))])

const filteredJobs = computed(() => {
  if (selectedStages.value.length > 0)
    return jobsList.value.filter(job => selectedStages.value.includes(job.stage))

  return jobsList.value
})

const jobCountByStatus = (stage: string) => {
  const statusCount: Record<string, number> = {}

  jobsList.value.forEach(job => {
    if (job.stage === stage)
      statusCount[job.status] = (statusCount[job.status] || 0) + 1
  })

  return statusCount
}

const pipelineStatusUpdate = async () => {
  console.log('[pipelineStatusUpdate] job retry triggered, update view !!! ')
  await getPipeline()
  await getJobsList()
  statusRequest()
}

const toggleSelectAll = () => {
  if (selectAll.value)
    selectedJobStatus.value = defaultJobStatus
  else
    selectedJobStatus.value = []
}

function reset() {
  selectedJobStatus.value = defaultJobStatus
  store.commit('setSelectedJobStatus', selectedJobStatus.value)
};

const getJobsList = async () => {
  const gitHelperApi = new GitlabHelperApi()

  console.log('getJobsList: idProject: ', projectId.value, ' idPipeline: ', pipelineId.value)
  try {
    const response = await gitHelperApi.getJobsList(projectId.value.toString(), pipelineId.value.toString(), [])

    jobsList.value = response.data.data
  }
  catch (error) {
    console.error('ERROR! getJobsList', error)
  }
}

// Function to handle toggling of job expansion
function handleExpandToggle(jobId: number) {
  const index = expandedJobIds.value.indexOf(jobId) // Access the ref using .value
  if (index === -1)
    expandedJobIds.value.push(jobId) // Add jobId if not already expanded
  else
    expandedJobIds.value.splice(index, 1) // Remove jobId if already expanded
};

function getJobIcon(status: string) {
  switch (status) {
    case 'success':
      return { icon: 'tabler-circle-check', color: '#4CAF50' }
    case 'failed':
      return { icon: 'tabler-alert-circle', color: '#F44336' }
    case 'running':
      return { icon: 'tabler-loader', color: '#2196F3' }
    case 'pending':
      return { icon: 'tabler-clock', color: '#FFC107' }
    case 'canceled':
      return { icon: 'tabler-circle-x', color: '#9E9E9E' }
    case 'skipped':
      return { icon: 'tabler-circle-chevrons-right', color: '#E0E0E0' }
    case 'manual':
      return { icon: 'tabler-hand-click', color: '#9C27B0' }
    case 'created':
      return { icon: 'tabler-circle-plus', color: '#03A9F4' }
    case 'preparing':
      return { icon: 'tabler-settings', color: '#FFC107' }
    case 'scheduled':
      return { icon: 'tabler-calendar-event', color: '#00BCD4' }
    case 'waiting_for_resource':
      return { icon: 'tabler-hourglass', color: '#FFEB3B' }
    case 'failed_with_warnings':
      return { icon: 'tabler-alert-triangle', color: '#FFC107' }
    default:
      return { icon: 'tabler-circle', color: '#607D8B' }
  }
};

async function cancelPipeline() {
  canceling.value = true

  const gitApi = new GitApiCall()
  try {
    await gitApi.cancelPipeline(projectId.value.toString(), pipelineId.value.toString())
    getPipeline()
  }
  catch (error) {
    console.error('ERROR! cancelPipeline', error)
  }
  finally {
    canceling.value = false
  }
};

const getPipeline = async () => {
  const gitApi = new GitApiCall()
  try {
    const response = await gitApi.getPipeline(projectId.value.toString(), pipelineId.value.toString())

    pipeline.value = response.data
    console.log('getPipeline this.pipeline:', pipeline.value)
  }
  catch (error) {
    console.error('ERROR! getPipeline error: ', error)
  }
}

const statusRequest = async () => {
  console.log('statusRequest pipeline.status: ', pipeline.value.status)

  const needUpdate = [
    'created',
    'waiting_for_resource',
    'preparing',
    'pending',
    'running',
    'manual',
    'scheduled',
  ]

  // add timer part
  if (needUpdate.includes(pipeline.value.status)) {
    // Clear existing timer if any
    if (timer.value !== null)
      clearTimeout(timer.value)

    // Set a new timer
    timer.value = setTimeout(async () => {
      console.log('Timer fired, sending request')
      await getPipeline()
      await getJobsList()
      statusRequest()
    }, 10000) as unknown as number
  }
  else {
    // Clear timer if status does not need updating
    if (timer.value !== null)
      clearTimeout(timer.value)
  }
}

const viewComponent = computed(() => {
  switch (selectedJobPreview.value) {
    case 'horizontal':
      return 'JobsListHorizontal'
    case 'stages':
      return 'StagesListVertical'
    default:
      return 'JobsListHorizontal'
  }
})

async function updatepipelineView(pipelineView: any) {
  console.log('[updatepipelineView] selected view:', pipelineView)
  emit('selected-value', pipelineView)
};

const getProject = async () => {
  const gitApi = new GitApiCall()
  try {
    const response = await gitApi.getSingleProject(projectId.value.toString())

    project.value = response.data
    console.log('getProject this.project:', project.value)
  }
  catch (error) {
    console.error('ERROR! getProject error: ', error)
  }
}

const getFormsJobsContent = async () => {
  const git = new GitApiCall()
  try {
    const response = await git.getFileContent(projectId.value.toString(), `ui%2Fforms%2Fjobs.json/raw?ref=${pipeline.value.ref}`)

    formJobsContent.value = response.data
    console.log('getFormsJobsContent this.fileContentData: ', formJobsContent.value)
  }
  catch (error) {
    formJobsContent.value = {}
    console.error('ERROR! getProjects', error)
  }
}

onMounted(() => {
  console.log('route is : ', route)
  console.log('store is : ', store)
  user.value = store.state.user
  groupId.value = route.params.id
  projectId.value = route.params.projectId
  pipelineId.value = route.params.pipelineId
  selectedJobStatus.value = store.state.selectedJobStatus
    ? store.state.selectedJobStatus
    : [
        { key: 'created', value: 'Created' },
        { key: 'waiting_for_resource', value: 'Waiting for resource' },
        { key: 'preparing', value: 'Preparing' },
        { key: 'pending', value: 'Pending' },
        { key: 'running', value: 'Running' },
        { key: 'manual', value: 'Manual' },
        { key: 'success', value: 'Success' },
        { key: 'failed', value: 'Failed' },
        { key: 'scheduled', value: 'Scheduled' },
        { key: 'canceling', value: 'Canceling' },
        { key: 'canceled', value: 'Canceled' },
        { key: 'skipped', value: 'Skipped' },
      ]
  selectedValues.value = selectedJobStatus.value.map(status => status.key)
  getProject()
  getFormsJobsContent()
  getPipeline()
  getJobsList()
  statusRequest()
})

watch(selectedJobStatus, () => {
  selectedValues.value = selectedJobStatus.value.map(status => status.key)
}, { deep: true })

watch(uniqueStages, (newStages: string[]) => {
  selectedStages.value = newStages
})
</script>

<template>
  <VCard class="mt-2">
    <HeaderTemplate
      :pipeline="pipeline"
      :group-id="groupId"
      :route="`${route}-workspace`"
      :project="project"
      :user="user"
    />
    <VCardText>
      <VRow>
        <!-- Pipeline View Dropdown -->
        <VCol
          cols="12"
          md="3"
          class="mb-md-0 mb-2"
        >
          <VSelect
            v-model="selectedJobPreview"
            :items="jobPreviewOptions"
            item-value="value"
            item-title="text"
            label="Pipeline View"
            :menu-props="{ offsetY: true }"
            :hide-details="true"
            dense
            @update:model-value="updatepipelineView"
          />
        </VCol>
        <!-- Pipeline Stages Filter Dropdown -->
        <VCol
          cols="10"
          md="5"
          class="mb-md-0 mb-2"
        >
          <VCombobox
            v-model="selectedJobStatus"
            chips
            clearable
            multiple
            closable-chips
            clear-icon="tabler-circle-x"
            :items="defaultJobStatus"
            item-value="key"
            item-title="value"
            label="Job status filter"
          />
        </VCol>
        <VCol
          cols="2"
          md="2"
          class="pa-0 mb-md-0 mb-2"
        >
          <VBtn
            color="primary"
            variant="outlined"
            icon="tabler-filter-off"
            class="mt-4"
            size="x-small"
            @click="reset"
          />
        </VCol>
      </VRow>
      <!-- Job List based on selected view -->
      <VContainer>
        <VRow>
          <VCol
            cols="12"
            class="text-center"
          >
            <VLabel>Select Stages to Filter Jobs:</VLabel>
          </VCol>
        </VRow>
      </VContainer>
      <!-- Stage Slide Group -->
      <VSheet
        class="mx-auto mb-10"
        elevation="8"
        max-width="800"
        max-height="200"
      >
        <VSlideGroup
          :key="slideGroupKey"
          v-model="selectedStages"
          class="pa-4 bg-grey-100"
          selected-class="bg-info"
          multiple
          center-active
          show-arrows
        >
          <VSlideGroupItem
            v-for="stage in uniqueStages"
            :key="stage"
            v-slot="{ isSelected, toggle, selectedClass }"
            :value="stage"
          >
            <VCard
              class="ma-4"
              :class="[selectedClass]"
              height="70"
              width="150"
              @click="toggle"
            >
              <div
                class="d-flex fill-height align-center justify-center"
                style="word-wrap:break-word;"
              >
                <div class="pl-2 text-caption">
                  {{ stage.toLocaleUpperCase() }}
                </div>
                <VScaleTransition>
                  <VIcon
                    v-if="isSelected"
                    color="white"
                    icon="tabler-checkbox"
                    size="24"
                  />
                </VScaleTransition>
              </div>
            </VCard>
          </VSlideGroupItem>
        </VSlideGroup>
      </VSheet>
      <VContainer class="mx-auto">
        <VExpansionPanels
          v-model="panel"
          multiple
          variant="popout"
        >
          <VExpansionPanel
            v-for="stage in uniqueStages"
            v-show="selectedStages.includes(stage)"
            :key="stage"
            rounded
            class="mt-4"
            :style="{ border: '1px  gray', borderLeft: '4px solid lightblue' }"
          >
            <VExpansionPanelTitle>
              <VRow class="align-center">
                <VCol>
                  <strong>{{ stage.toLocaleUpperCase() }}</strong>
                </VCol>
                <VCol class="d-flex justify-end">
                  <span v-if="jobCountByStatus(stage)">
                    <template
                      v-for="(count, status) in jobCountByStatus(stage)"
                      :key="status"
                    >
                      <VChip
                        :color="statusColors[status]"
                        text-color="white"
                        class="ma-1"
                      >
                        {{ status }}: {{ count }}
                      </VChip>
                    </template>
                  </span>
                </VCol>
              </VRow>
            </VExpansionPanelTitle>
            <VDivider />
            <VExpansionPanelText>
              <VRow class="pa-3 pt-6">
                <VCol
                  v-for="job in filteredJobs"
                  v-show="job.stage == stage && selectedValues.includes(job.status)"
                  :key="job.id"
                  :cols="expandedJobIds.includes(job.id) ? 12 : 12"
                  :sm="expandedJobIds.includes(job.id) ? 12 : 6"
                  :md="expandedJobIds.includes(job.id) ? 12 : 4"
                  :lg="expandedJobIds.includes(job.id) ? 12 : 3"
                  :xl="expandedJobIds.includes(job.id) ? 12 : 3"
                >
                  <VSheet class="pb-4">
                    <VRow class="pa-0">
                      <VCol
                        cols="12"
                        class="d-flex pa-0 justify-center align-center"
                      >
                        <VIcon
                          :icon="getJobIcon(job.status).icon"
                          :color="getJobIcon(job.status).color"
                        />
                        <VDivider />
                      </VCol>
                    </VRow>
                    <VRow class="pa-0 pt-2 pl-5">
                      <JobItem
                        :key="job.id"
                        :job="job"
                        :project="project"
                        :group-id="groupId"
                        @expand-toggle="handleExpandToggle"
                        @retry-job="pipelineStatusUpdate"
                      />
                    </VRow>
                  </VSheet>
                </VCol>
              </VRow>
            </VExpansionPanelText>
          </VExpansionPanel>
        </VExpansionPanels>
      </VContainer>
      <VRow justify="end">
        <VBtn
          color="error"
          class="mt-2"
          :loading="canceling || spinning"
          :disabled="canceling || ['canceled', 'success', 'failed'].includes(pipeline.status)"
          @click="cancelPipeline"
        >
          Cancel pipeline
        </VBtn>
      </VRow>
    </VCardText>
  </VCard>
</template>

<style scoped>
.mt-5 {
  margin-top: 1.5rem;
}

.mt-2 {
  margin-top: 0.5rem;
}

.mb-1 {
  margin-bottom: 0.25rem;
}
</style>
